DECLARE SUB enter.dungeon (mista AS INTEGER)
DECLARE SUB create.grassy ()
DECLARE SUB save.map (file$)
DECLARE SUB add.item.map (x AS INTEGER, y AS INTEGER, it AS INTEGER)
DECLARE FUNCTION last.item% (pala AS ANY)
DECLARE SUB make.enemy (typ AS INTEGER)
DECLARE SUB plan.enemies ()
DECLARE SUB put.doors ()
DECLARE SUB create.random.forest ()
DECLARE SUB create.random.dungeon ()
DECLARE SUB make.room (x AS INTEGER, y AS INTEGER, w AS INTEGER, h AS INTEGER)
DECLARE SUB init.map ()

'crfield.bas - ksittelee karttojen luomista.
'lukee map.dat:sta minklainen maailma pit tehd
'jos tyyli = kyl, ladataan ennaltaluotu tiedosto - kyl ei kovin kki muutu!
'ohjelma luo aina uuden kartan!

'kopioitu suoraan qworld:sta, kaikkia ei tarvita
CONST max.x = 80, max.y = 30
CONST MAX.INTEGER = 32767 'max arvo int:ill
CONST max.monsters = 50 'montako monsua max. / kartta
CONST max.items = 100 'montako esinett max. / kartta. (ei sisll vaerastoja!)
CONST MAX.WEAPONS = 100 'montako erilaista asetta
CONST MAX.BOOK = 15 'montako erilaista kirjaa
CONST MAX.BOTTLES = 5 'montako erilaista juomaa
CONST MAX.ARMOR = 25 'montako erilaista panssaria
CONST MAX.PLAYER = 5 'max. pelaajia mukana
CONST MAX.H.TYPE = 5 'max. hirvityyppi / kentt

CONST world.style.dungeon = 0 'luolasto
CONST world.style.village = 1 'kyl...
CONST world.style.forest = 2 'meht
CONST world.style.hell = 3 'helgutti
CONST world.style.grassland = 4

CONST esine.ase = 0
CONST esine.kirja = 1
CONST esine.juoma = 2
CONST esine.panssari = 3
CONST esine.kilpi = 4
CONST esine.kypara = 5

CONST obj.maa = 0
  CONST OBJ.MAA.TUNNELI = 0
  CONST OBJ.MAA.LATTIA = 1

CONST obj.este = 1
  CONST OBJ.ESTE.MUURI = 0
  CONST OBJ.ESTE.VETTA = 1

CONST obj.ovi = 2
  CONST OBJ.OVI.AUKI = 0
  CONST OBJ.OVI.KIINNI = 1
  CONST OBJ.OVI.LUKITTU = 2
  CONST OBJ.OVI.SALA = 3

CONST OBJ.KASVI = 3
  CONST OBJ.KASVI.TUTKIMATON = 0
  CONST OBJ.KASVI.TUTKITTU = 1

CONST OBJ.PORTAAT = 4
  CONST OBJ.PORTAAT.YLOS = 0
  CONST OBJ.PORTAAT.ALAS = 1

TYPE map
  dat AS INTEGER
  yleisobj AS INTEGER 'katso yll
  erikobj AS INTEGER  'erikoistuotanto
  itemlink AS INTEGER 'alkulinkki esineeseen - 0=ei esinett
  oliolink AS INTEGER 'linkki elolliseen olioon - 0=ei oliota, -1 = pelaaja
END TYPE
DIM SHARED kartta(1 TO max.x, 1 TO max.y) AS map, world.style AS INTEGER, pelaajia AS INTEGER, kerros AS INTEGER

TYPE ITEM
  tyyppi AS INTEGER 'mik luokka?
  linkki AS INTEGER 'linkki tyypin mrittelemn esineeseen
  ketju AS INTEGER 'linkki seuraavaan esineeseen
END TYPE
DIM SHARED esineet(1 TO max.items)  AS ITEM

TYPE MONSTERMAIN 'hirvin ptyyppi
  nimi AS STRING * 20
  file AS STRING * 20
  elomax AS INTEGER 'kuinka paljon elm (max)
  range AS INTEGER 'kuinka pitkn matkan pst hirvi alkaa tulemaan kohti
  steps AS INTEGER 'kuinka monta askelta hirvi liikkuu / vuoro?
  spec AS INTEGER  'speciaalikyky
  pase AS INTEGER
END TYPE
DIM SHARED hirvioluokka(1 TO MAX.H.TYPE) AS MONSTERMAIN

TYPE monster 'linkkihirvi
  tyyppi AS INTEGER 'linkki phirveln
  x AS INTEGER
  y AS INTEGER
  elo AS INTEGER 'paljonko elm
  onoff AS INTEGER 'onko kytss
  ase AS INTEGER
END TYPE
DIM SHARED hirviot(1 TO max.monsters) AS monster, NUMOFM AS INTEGER

DIM SHARED enemyn AS STRING * 20 'vihollisnimi
DIM SHARED enemyf AS STRING * 20 'kuvatiedosto
DIM SHARED ekyky AS INTEGER 'vihollisen erikoiskyky 0=ei kyky ,<0=loitsu,>0=special
DIM SHARED enemyelo AS INTEGER 'vihollisen max.elo
DIM SHARED enemyrange AS INTEGER 'vihollisen range
DIM SHARED enemymp AS INTEGER 'vihollisen liikepisteet
DIM SHARED enemyase AS INTEGER
DIM SHARED komennot AS INTEGER

DIM SHARED ylos.file AS STRING * 12 'minne mennn rappusista
DIM SHARED alas.file AS STRING * 12

'vihollistyypit
CONST animal = 0, undead = 1, bug = 2, orcy = 3, bigundead = 4, greatundead = 5
'bittimuuttujat
CONST viholliset = 1, raputylos = 2, raputalas = 4

RANDOMIZE TIMER

DIM kutsuja$, mfile$
mfile$ = ""
OPEN "map.dat" FOR INPUT AS #2
  INPUT #2, world.style, pelaajia
  INPUT #2, komennot  'komentoluku
  INPUT #2, kutsuja$
  INPUT #2, mfile$ 'minne tallennetaan
CLOSE #2

IF kutsuja$ = "main.bas" THEN
  ylos.file = "XXXX": kerros = 0 'kutsuttiin ppelist eli tultiin maanpinnalta eli kerros=1
  IF world.style = world.style.dungeon THEN
    alas.file = "D" + MID$(mfile$, 2, 4) + "02.map" 'eli Dxxyy02 eli koordinaattien toinen kerros
  END IF
ELSE 'kutsuttiin muualta - kutsuja$ sis. edellisen kartan nimen (+.map)
  IF LEFT$(kutsuja$, 1) = "D" THEN
    vali$ = MID$(mfile$, 1, 5)'viisi ekaa merkki - tunnistin ja koordinaatit
    k% = VAL(MID$(mfile$, 6, 2)) 'esim. dxxyy02.map -> 02
    IF k% < 9 THEN vali$ = vali$ + "0" + LTRIM$(RTRIM$(STR$(k% - 1))) ELSE vali$ = vali$ + LTRIM$(RTRIM$(STR$(k% - 1)))'muutetaan kerrosta
    vali$ = vali$ + ".map"
    ylos.file = vali$
    IF k% = 1 THEN ylos.file = "XXXX"
    vali$ = MID$(mfile$, 1, 5)'viisi ekaa merkki - tunnistin ja koordinaatit
    k% = VAL(MID$(mfile$, 6, 2)) 'esim. dxxyy02.map -> 02
    IF k% < 9 THEN vali$ = vali$ + "0" + LTRIM$(RTRIM$(STR$(k% + 1))) ELSE vali$ = vali$ + LTRIM$(RTRIM$(STR$(k% + 1)))'muutetaan kerrosta
    vali$ = vali$ + ".map"
    alas.file = vali$
  END IF
END IF
  
create% = 0'ei luoda
ON ERROR GOTO errori

OPEN mfile$ FOR INPUT AS #2
CLOSE #2

IF create% = 1 THEN 'pit luoda uusi - ryhmitytn siis ylportaille
  IF world.style = world.style.dungeon THEN
    CALL create.random.dungeon
    CALL put.doors
    CALL enter.dungeon(0) 'tullaan ylsportaille
  ELSEIF world.style = world.style.forest THEN
    CALL create.random.forest
  ELSEIF world.style = world.style.grassland THEN
    CALL create.grassy
  END IF

  CALL plan.enemies 'suunnitellaan viholliset
  CALL save.map(mfile$)
ELSE

END IF

RUN "qworld.bas"  'mennn peliin

errori:  'tnne tullaan, jos tiedostoa ei lydy
  IF ERR = 53 THEN 'tiedostoa ei lydy
    create% = 1
  ELSE
 
  END IF
  RESUME NEXT

SUB add.item.map (x AS INTEGER, y AS INTEGER, it AS INTEGER)
  IF kartta(x, y).itemlink = 0 THEN
    kartta(x, y).itemlink = it
  ELSE
    esineet(last.item(kartta(x, y))).ketju = it
  END IF
END SUB

SUB create.grassy
  CALL init.map
  FOR x% = 1 TO max.x
  FOR y% = 1 TO max.y
    IF INT(RND * 20) <> 0 THEN
      kartta(x%, y%).yleisobj = obj.maa
      kartta(x%, y%).erikobj = OBJ.MAA.TUNNELI
    ELSE
      kartta(x%, y%).yleisobj = OBJ.KASVI
      kartta(x%, y%).erikobj = OBJ.KASVI.TUTKIMATON
    END IF
  NEXT y%, x%
  x1% = 40: y1% = 15
  FOR kuka = 1 TO pelaajia
    x% = x1%: y% = y1%
    WHILE (kartta(x%, y%).yleisobj = obj.este OR kartta(x%, y%).oliolink <> 0)
      x% = INT(RND * 5) - 2 + x1%: y% = INT(RND * 5) - 2 + y1%
    WEND
    kartta(x%, y%).oliolink = -kuka
  NEXT
END SUB

SUB create.random.dungeon
  'luodaan sattumanvarainen luolasto
  CALL init.map
  maxroom = INT(INT(max.x / 10) * INT(max.y / 10))'lasketaan huoneitten mr
  DIM rx(1 TO maxroom) AS INTEGER, ry(1 TO maxroom) AS INTEGER
  DIM rs(1 TO maxroom, 1 TO 2) AS INTEGER
  'haetaan huoneiden sijainnit
  'huoneen 1 sijainti ja koko
  x% = 1: y% = 1: q = 1
  FOR r = 1 TO maxroom
    x% = x% + 10
    IF x% >= max.x THEN y% = y% + 10: x% = 1
    IF y% >= max.y THEN EXIT FOR
    IF INT(RND * 2) = 1 THEN
      rx(q) = x% + 1 + INT(RND * 3): ry(q) = y% + 1 + INT(RND * 3)
      rs(q, 1) = 3 + INT(RND * (x% + 10 - rx(q) - 2))
      rs(q, 2) = 3 + INT(RND * (y% + 10 - ry(q) - 2))
      laajuus% = laajuus% + 1
      q = q + 1
    END IF
  NEXT r
  'sekoitetaan huoneiden jrjestys!
  FOR r = 1 TO laajuus%
    IF INT(RND * 3) = 0 THEN
      q% = INT(RND * r) + 1 'mink kanssa
      w% = rx(r): rx(r) = rx(q%): rx(q%) = w%
      w% = ry(r): ry(r) = ry(q%): ry(q%) = w%
    END IF
  NEXT r
  'laitetaan huoneet
  FOR r = 1 TO laajuus%
    CALL make.room(rx(r), ry(r), rs(r, 1), rs(r, 2))
    rx(r) = rx(r) + INT(RND * rs(r, 1)) + 1
    IF rx(r) > max.x - 2 THEN rx(r) = max.x - 3
    ry(r) = ry(r) + INT(RND * rs(r, 2))
    IF ry(r) > max.y - 2 THEN ry(r) = max.y - 3
  NEXT r
  'piirretn yhteydet!
  w% = INT(RND * 2) - 1'piirretnk x(0) vai y(-1) suunnassa
  q% = 0' onko piirrosestett?
  FOR r = 1 TO laajuus% - 1
    x% = rx(r): y% = ry(r)
    DO
      IF w% = 0 THEN
        IF x% < rx(r + 1) THEN
          x% = x% + 1
        ELSEIF x% > rx(r + 1) THEN
          x% = x% - 1
        END IF
      ELSE
        IF y% < ry(r + 1) THEN
          y% = y% + 1
        ELSEIF y% > ry(r + 1) THEN
          y% = y% - 1
        END IF
      END IF
   
      IF INT(RND * 5) = 0 OR y% = ry(r + 1) OR x% = rx(r + 1) THEN w% = (w% = 0)
    
      IF x% = rx(r + 1) AND y% = ry(r + 1) THEN EXIT DO

      IF kartta(x%, y%).yleisobj = obj.este AND q% = 0 THEN
        kartta(x%, y%).yleisobj = obj.maa
        kartta(x%, y%).yleisobj = OBJ.MAA.TUNNELI
      END IF
    LOOP
  NEXT r
 
  IF (komennot AND raputylos) THEN 'etsitn yls-portaille paikka
    x% = 1: y% = 1
    WHILE (kartta(x%, y%).yleisobj <> obj.maa OR kartta(x%, y%).erikobj <> OBJ.MAA.LATTIA)
      x% = INT(RND * max.x - 6) + 3: y% = INT(RND * max.y - 6) + 3
    WEND
    kartta(x%, y%).yleisobj = OBJ.PORTAAT
    kartta(x%, y%).erikobj = OBJ.PORTAAT.YLOS
    x1% = x%: y1% = y%
  END IF
  IF (komennot AND raputalas) THEN 'etsitn alas-portaille paikka
    x% = 1: y% = 1
    WHILE (kartta(x%, y%).yleisobj <> obj.maa OR kartta(x%, y%).erikobj <> OBJ.MAA.LATTIA)
      x% = INT(RND * max.x - 6) + 3: y% = INT(RND * max.y - 6) + 3
    WEND
    kartta(x%, y%).yleisobj = OBJ.PORTAAT
    kartta(x%, y%).erikobj = OBJ.PORTAAT.ALAS
    x1% = x%: y1% = y%
  END IF
 
 
  'FOR kuka = 1 TO pelaajia
  '  x% = x1%: y% = y1%
  '  WHILE (kartta(x%, y%).yleisobj = obj.este OR kartta(x%, y%).oliolink <> 0)
  '    x% = INT(RND * 5) - 2 + x1%: y% = INT(RND * 5) - 2 + y1%
  '  WEND
  '  kartta(x%, y%).oliolink = -kuka
  'NEXT
 
  q% = INT(RND * (max.items - 80)) + 1 'esineit kartalle!
  FOR a% = 1 TO q%
    x% = 1: y% = 1
    WHILE (kartta(x%, y%).yleisobj <> obj.maa OR kartta(x%, y%).erikobj <> OBJ.MAA.LATTIA)
      x% = INT(RND * max.x) + 1: y% = INT(RND * max.y) + 1
    WEND
    CALL add.item.map(x%, y%, a%)
    esineet(a%).tyyppi = INT(RND * 6)
    SELECT CASE esineet(a%).tyyppi
      CASE esine.ase: esineet(a%).linkki = INT(RND * 20) + 1'ensimmiset 20
      CASE esine.juoma: esineet(a%).linkki = INT(RND * 5) + 1 ' mit tahansa
      CASE esine.kirja: esineet(a%).linkki = INT(RND * 3) + 1'
      CASE IS >= esine.panssari: esineet(a%).linkki = INT(RND * 8) + 1
    END SELECT
  NEXT a%
END SUB

SUB create.random.forest
  CALL init.map
  FOR x% = 1 TO max.x
  FOR y% = 1 TO max.y
    SELECT CASE INT(RND * 14)
      CASE IS < 4:  kartta(x%, y%).yleisobj = obj.maa
                    kartta(x%, y%).erikobj = OBJ.MAA.TUNNELI
      CASE 4 TO 12:  kartta(x%, y%).yleisobj = OBJ.KASVI
                    kartta(x%, y%).erikobj = OBJ.KASVI.TUTKIMATON
      CASE 13:      kartta(x%, y%).yleisobj = obj.este
                    kartta(x%, y%).erikobj = OBJ.ESTE.VETTA
    END SELECT
  NEXT y%, x%
  x1% = 40: y1% = 15
  FOR kuka = 1 TO pelaajia
    x% = x1%: y% = y1%
    WHILE (kartta(x%, y%).yleisobj = obj.este OR kartta(x%, y%).oliolink <> 0)
      x% = INT(RND * 5) - 2 + x1%: y% = INT(RND * 5) - 2 + y1%
    WEND
    kartta(x%, y%).oliolink = -kuka
  NEXT
END SUB

SUB enter.dungeon (mista AS INTEGER)
  FOR x% = 1 TO max.x
  FOR y% = 1 TO max.y
    IF kartta(x%, y%).yleisobj = OBJ.PORTAAT THEN
      IF kartta(x%, y%).erikobj = OBJ.PORTAAT.ALAS AND mista = 1 THEN
        x1% = x%: y1% = y%: EXIT FOR
      ELSEIF kartta(x%, y%).erikobj = OBJ.PORTAAT.YLOS AND mista = 0 THEN
        x1% = x%: y1% = y%: EXIT FOR
      END IF
    END IF
  NEXT y%, x%
  'haetaan sangar(e)ille aloituspaikka
  FOR kuka = 1 TO pelaajia
    x% = x1%: y% = y1%
    WHILE (kartta(x%, y%).yleisobj = obj.este OR kartta(x%, y%).oliolink <> 0)
      x% = INT(RND * 5) - 2 + x1%: y% = INT(RND * 5) - 2 + y1%
    WEND
    kartta(x%, y%).oliolink = -kuka
  NEXT
END SUB

SUB init.map
  FOR y% = 1 TO max.y
  FOR x% = 1 TO max.x
    kartta(x%, y%).dat = 0
    kartta(x%, y%).yleisobj = obj.este
    kartta(x%, y%).erikobj = OBJ.ESTE.MUURI
  NEXT x%, y%
  FOR x% = 1 TO max.items
    esineet(x%).tyyppi = -1 'off
  NEXT x%
END SUB

FUNCTION last.item% (pala AS map)
  a% = pala.itemlink: B% = 0
  IF a% = 0 THEN B% = -1 ELSE B% = 1
  DO
    IF a% = 0 OR B% < 1 THEN EXIT DO'=0 jo ketjun viimeinen, -1 jos palassa ei lainkaan esinett
    B% = a% 'esineen numero
    a% = esineet(a%).ketju
  LOOP
  last.item% = B%
END FUNCTION

SUB make.enemy (typ AS INTEGER)
  ekyky = 0  'oletus
  SELECT CASE kerros

  END SELECT
  SELECT CASE typ
    CASE animal:
      enemyase = 0
      SELECT CASE INT(RND * 4) + hard%
        CASE 0:
          enemyn = "Squirrel"
          enemyf = "squirrel.pic"
          enemyelo = 3
          enemyrange = 4
          enemymp = 2
        CASE 1:
          enemyn = "Rat"
          enemyf = "rat.pic"
          enemyelo = 2
          enemyrange = 3
          enemymp = 2
        CASE 2:
          enemyn = "Cave lizard"
          enemyf = "lizard.pic"
          enemyelo = 8
          enemyrange = 4
          enemymp = 4
        CASE 3:
          enemyn = "Basilisk"
          enemyf = "lizard.pic"
          enemyelo = 12
          enemyrange = 4
          enemymp = 5
          ekyky = 1 'kuolonkatse
      END SELECT
    CASE undead:
      SELECT CASE INT(RND * 6) + hard%
        CASE 0:
          enemyn = "Skeleton"
          enemyf = "skeleton.pic"
          enemyelo = 5
          enemyrange = 4
          enemymp = 4
          enemyase = INT(RND * 4) + 1
        CASE 1:
          enemyn = "Skeleton archer"
          enemyf = "skelarch.pic"
          enemyelo = 4
          enemyrange = 6
          enemymp = 4
          enemyase = 16 'linko
        CASE 2:
          enemyn = "Greater skeleton"
          enemyf = "skeleton.pic"
          enemyelo = 8
          enemyrange = 6
          enemymp = 4
          enemyase = 5 + INT(RND * 4) 'pelottavampia aseita
        CASE 3:
          enemyn = "Zombie"
          enemyf = "zombie.pic"
          enemyelo = 5
          enemyrange = 3
          enemymp = 2
          enemyase = INT(RND * 3)
          ekyky = 2 'paralyysi
        CASE 4:
          enemyn = "Ghoul"
          enemyf = "ghoul.pic"
          enemyelo = 7
          enemyrange = 9
          enemymp = 4
          enemyase = 0
          ekyky = 2 'paralyysi
        CASE 5:
          enemyn = "Ghul"
          enemyf = "ghoul.pic"
          enemyelo = 11
          enemyrange = 9
          enemymp = 5
          enemyase = 0
          ekyky = 2 'paralyysi
        END SELECT
    CASE orcy:
      SELECT CASE INT(RND * 7) + hard%
        CASE 0:
          enemyn = "Squeezing troll"
          enemyf = "imp.pic"
          enemyelo = 4
          enemyrange = 5
          enemymp = 3
          enemyase = INT(RND * 2) + 1
          ekyky = 3 'squiik!!!

        CASE 1:
          enemyn = "Goblin"
          enemyf = "goblin.pic"
          enemyelo = 5
          enemyrange = 4
          enemymp = 3
          enemyase = INT(RND * 3) + 1

        CASE 2:
          enemyn = "Orc"
          enemyf = "orc.pic"
          enemyelo = 7
          enemyrange = 4
          enemymp = 3
          enemyase = INT(RND * 6) + 1
      
        CASE 3: 'pieni ja heikohko luolaogre
          enemyn = "Cave ogre"
          enemyf = "greatorc.pic"
          enemyelo = 30
          enemyrange = 4
          enemymp = 2
          enemyase = INT(RND * 2) + 8
          ekyky = 10 'voimaisku
       
        CASE 4:
          enemyn = "Dark orc"
          enemyf = "dorc.pic"
          enemyelo = 10
          enemyrange = 15 'haistaa/kuulee/maistaa kauas!
          enemymp = 3
          enemyase = INT(RND * 8) + 4

        CASE 5:
          enemyn = "Great orc"
          enemyf = "greatorc.pic"
          enemyelo = 20
          enemyrange = 4
          enemymp = 3
          enemyase = INT(RND * 6) + 1
          ekyky = 10 'voimaisku
    
        CASE 6:
          enemyn = "Mighty ogre"
          enemyf = "vogre.pic"
          enemyelo = 60
          enemyrange = 4
          enemymp = 3
          enemyase = 33 'too strong...
          ekyky = 10 'voimaisku

      END SELECT
  END SELECT
END SUB

SUB make.room (x AS INTEGER, y AS INTEGER, w AS INTEGER, h AS INTEGER)
  FOR y1 = y TO y + h
  FOR x1 = x TO x + w
    IF x1 < max.x - 1 AND y1 < max.y - 1 THEN
      kartta(x1, y1).yleisobj = obj.maa
      kartta(x1, y1).erikobj = OBJ.MAA.LATTIA
    END IF
  NEXT x1, y1
END SUB

'suunnitellaan viholliset
SUB plan.enemies
  FOR a% = 1 TO 5
    SELECT CASE world.style
      CASE world.style.dungeon:
        SELECT CASE INT(RND * 2)
          CASE 0: make.enemy undead
          CASE 1: make.enemy orcy
        END SELECT
      CASE world.style.forest, world.style.grassland:
        SELECT CASE INT(RND * 1)
          CASE 0: make.enemy orcy
          'CASE 1: make.enemy orcy
        END SELECT
    END SELECT
    hirvioluokka(a%).nimi = enemyn
    hirvioluokka(a%).file = enemyf
    hirvioluokka(a%).elomax = enemyelo
    hirvioluokka(a%).range = enemyrange
    hirvioluokka(a%).steps = enemymp
    hirvioluokka(a%).pase = enemyase
    hirvioluokka(a%).spec = ekyky
  NEXT a%
  'alustetaan
  FOR kuka = 1 TO max.monsters
    hirviot(kuka).onoff = 0 'ei pll
  NEXT kuka
  'laitetaan hirvit kartalle
  IF (komennot AND viholliset) THEN
    q% = INT(RND * (max.monsters - 20)) + 15
    FOR kuka = 1 TO q%
      x% = 1: y% = 1
      WHILE (kartta(x%, y%).yleisobj = obj.este OR kartta(x%, y%).oliolink <> 0)
        x% = INT(RND * (max.x - 2)) + 2: y% = INT(RND * (max.y - 2)) + 2
      WEND
      kartta(x%, y%).oliolink = kuka
      hirviot(kuka).x = x%: hirviot(kuka).y = y%
      hirviot(kuka).tyyppi = INT(RND * 5) + 1
      hirviot(kuka).ase = hirvioluokka(hirviot(kuka).tyyppi).pase
      hirviot(kuka).elo = hirvioluokka(hirviot(kuka).tyyppi).elomax
      hirviot(kuka).onoff = (1 = 1)'on
    NEXT kuka
  END IF
END SUB

SUB put.doors
  FOR x% = 2 TO max.x - 1
    FOR y% = 2 TO max.y - 1
    xm% = 0: ym% = 0
    IF kartta(x%, y%).yleisobj = obj.maa THEN 'ovi vain maalle
      IF kartta(x% + 1, y%).yleisobj = kartta(x% - 1, y%).yleisobj THEN xm% = kartta(x% + 1, y%).yleisobj
      IF kartta(x%, y% + 1).yleisobj = kartta(x%, y% - 1).yleisobj THEN ym% = kartta(x%, y% + 1).yleisobj
      IF (xm% = obj.maa AND ym% = obj.este) OR (ym% = obj.maa AND xm% = obj.este) THEN
        IF INT(RND * 30) = 0 THEN
          kartta(x%, y%).yleisobj = obj.ovi
          kartta(x%, y%).erikobj = INT(RND * 4)
        END IF
      END IF
    END IF
  NEXT y%, x%
END SUB

SUB save.map (file$)
  OPEN file$ FOR BINARY AS #1
  PUT #1, 1, world.style
  FOR x% = 1 TO max.x
    FOR y% = 1 TO max.y
      PUT #1, , kartta(x%, y%).dat
      PUT #1, , kartta(x%, y%).yleisobj
      PUT #1, , kartta(x%, y%).erikobj
      PUT #1, , kartta(x%, y%).oliolink
      PUT #1, , kartta(x%, y%).itemlink
  NEXT y%, x%
  FOR x% = 1 TO max.items
    PUT #1, , esineet(x%).linkki
    PUT #1, , esineet(x%).tyyppi
    PUT #1, , esineet(x%).ketju
  NEXT
  FOR x% = 1 TO 5
    PUT #1, , hirvioluokka(x%).nimi
    PUT #1, , hirvioluokka(x%).file
    PUT #1, , hirvioluokka(x%).elomax
    PUT #1, , hirvioluokka(x%).range
    PUT #1, , hirvioluokka(x%).steps
    PUT #1, , hirvioluokka(x%).pase
    PUT #1, , hirvioluokka(x%).spec
  NEXT
 
  PUT #1, , ylos.file
  PUT #1, , alas.file
 
  FOR x% = 1 TO max.monsters
    PUT #1, , hirviot(x%).tyyppi
    PUT #1, , hirviot(x%).x
    PUT #1, , hirviot(x%).y
    PUT #1, , hirviot(x%).elo
    PUT #1, , hirviot(x%).onoff
    PUT #1, , hirviot(x%).ase
  NEXT x%
  CLOSE #1
END SUB

